]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Remove useless NOTMUCH variable (in favor of simply "notmuch")
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
45
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
49
50 unset GREP_OPTIONS
51
52 # Convenience
53 #
54 # A regexp to match 5 and 40 hexdigits
55 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
56 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
57
58 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
59 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68                 TERM=$ORIGINAL_TERM &&
69                 export TERM &&
70                 [ -t 1 ] &&
71                 tput bold >/dev/null 2>&1 &&
72                 tput setaf 1 >/dev/null 2>&1 &&
73                 tput sgr0 >/dev/null 2>&1
74         ) &&
75         color=t
76
77 while test "$#" -ne 0
78 do
79         case "$1" in
80         -d|--d|--de|--deb|--debu|--debug)
81                 debug=t; shift ;;
82         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83                 immediate=t; shift ;;
84         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
86         -h|--h|--he|--hel|--help)
87                 help=t; shift ;;
88         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89                 verbose=t; shift ;;
90         -q|--q|--qu|--qui|--quie|--quiet)
91                 quiet=t; shift ;;
92         --with-dashes)
93                 with_dashes=t; shift ;;
94         --no-color)
95                 color=; shift ;;
96         --no-python)
97                 # noop now...
98                 shift ;;
99         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
100                 valgrind=t; verbose=t; shift ;;
101         --tee)
102                 shift ;; # was handled already
103         --root=*)
104                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
105                 shift ;;
106         *)
107                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
108         esac
109 done
110
111 if test -n "$color"; then
112         say_color () {
113                 (
114                 TERM=$ORIGINAL_TERM
115                 export TERM
116                 case "$1" in
117                         error) tput bold; tput setaf 1;; # bold red
118                         skip)  tput bold; tput setaf 2;; # bold green
119                         pass)  tput setaf 2;;            # green
120                         info)  tput setaf 3;;            # brown
121                         *) test -n "$quiet" && return;;
122                 esac
123                 shift
124                 printf " "
125                 printf "$@"
126                 tput sgr0
127                 )
128         }
129 else
130         say_color() {
131                 test -z "$1" && test -n "$quiet" && return
132                 shift
133                 printf " "
134                 printf "$@"
135         }
136 fi
137
138 error () {
139         say_color error "error: $*"
140         GIT_EXIT_OK=t
141         exit 1
142 }
143
144 say () {
145         say_color info "$*"
146 }
147
148 test "${test_description}" != "" ||
149 error "Test script did not set test_description."
150
151 if test "$help" = "t"
152 then
153         echo "Tests ${test_description}"
154         exit 0
155 fi
156
157 echo $(basename "$0"): "Testing ${test_description}"
158
159 exec 5>&1
160 if test "$verbose" = "t"
161 then
162         exec 4>&2 3>&1
163 else
164         exec 4>/dev/null 3>/dev/null
165 fi
166
167 test_failure=0
168 test_count=0
169 test_fixed=0
170 test_broken=0
171 test_success=0
172
173 die () {
174         code=$?
175         if test -n "$GIT_EXIT_OK"
176         then
177                 exit $code
178         else
179                 echo >&5 "FATAL: Unexpected exit with code $code"
180                 exit 1
181         fi
182 }
183
184 GIT_EXIT_OK=
185 trap 'die' EXIT
186
187 test_decode_color () {
188         sed     -e 's/.\[1m/<WHITE>/g' \
189                 -e 's/.\[31m/<RED>/g' \
190                 -e 's/.\[32m/<GREEN>/g' \
191                 -e 's/.\[33m/<YELLOW>/g' \
192                 -e 's/.\[34m/<BLUE>/g' \
193                 -e 's/.\[35m/<MAGENTA>/g' \
194                 -e 's/.\[36m/<CYAN>/g' \
195                 -e 's/.\[m/<RESET>/g'
196 }
197
198 q_to_nul () {
199         perl -pe 'y/Q/\000/'
200 }
201
202 q_to_cr () {
203         tr Q '\015'
204 }
205
206 append_cr () {
207         sed -e 's/$/Q/' | tr Q '\015'
208 }
209
210 remove_cr () {
211         tr '\015' Q | sed -e 's/Q$//'
212 }
213
214 # Notmuch helper functions
215 increment_mtime_amount=0
216 increment_mtime ()
217 {
218     dir="$1"
219
220     increment_mtime_amount=$((increment_mtime_amount + 1))
221     touch -d "+${increment_mtime_amount} seconds" "$dir"
222 }
223
224 # Generate a new message in the mail directory, with a unique message
225 # ID and subject. The message is not added to the index.
226 #
227 # After this function returns, the filename of the generated message
228 # is available as $gen_msg_filename and the message ID is available as
229 # $gen_msg_id .
230 #
231 # This function supports named parameters with the bash syntax for
232 # assigning a value to an associative array ([name]=value). The
233 # supported parameters are:
234 #
235 #  [dir]=directory/of/choice
236 #
237 #       Generate the message in directory 'directory/of/choice' within
238 #       the mail store. The directory will be created if necessary.
239 #
240 #  [body]=text
241 #
242 #       Text to use as the body of the email message
243 #
244 #  '[from]="Some User <user@example.com>"'
245 #  '[to]="Some User <user@example.com>"'
246 #  '[subject]="Subject of email message"'
247 #  '[date]="RFC 822 Date"'
248 #
249 #       Values for email headers. If not provided, default values will
250 #       be generated instead.
251 #
252 #  '[cc]="Some User <user@example.com>"'
253 #  [reply-to]=some-address
254 #  [in-reply-to]=<message-id>
255 #  [references]=<message-id>
256 #  [content-type]=content-type-specification
257 #  '[header]=full header line, including keyword'
258 #
259 #       Additional values for email headers. If these are not provided
260 #       then the relevant headers will simply not appear in the
261 #       message.
262 #
263 #  '[id]=message-id'
264 #
265 #       Controls the message-id of the created message.
266 gen_msg_cnt=0
267 gen_msg_filename=""
268 gen_msg_id=""
269 generate_message ()
270 {
271     # This is our (bash-specific) magic for doing named parameters
272     local -A template="($@)"
273     local additional_headers
274
275     gen_msg_cnt=$((gen_msg_cnt + 1))
276     gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
277
278     if [ -z "${template[id]}" ]; then
279         gen_msg_id="${gen_msg_name}@notmuch-test-suite"
280     else
281         gen_msg_id="${template[id]}"
282     fi
283
284     if [ -z "${template[dir]}" ]; then
285         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
286     else
287         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
288         mkdir -p "$(dirname "$gen_msg_filename")"
289     fi
290
291     if [ -z "${template[body]}" ]; then
292         template[body]="This is just a test message (#${gen_msg_cnt})"
293     fi
294
295     if [ -z "${template[from]}" ]; then
296         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
297     fi
298
299     if [ -z "${template[to]}" ]; then
300         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
301     fi
302
303     if [ -z "${template[subject]}" ]; then
304         template[subject]="Test message #${gen_msg_cnt}"
305     fi
306
307     if [ -z "${template[date]}" ]; then
308         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
309     fi
310
311     additional_headers=""
312     if [ ! -z "${template[header]}" ]; then
313         additional_headers="${template[header]}
314 ${additional_headers}"
315     fi
316
317     if [ ! -z "${template[reply-to]}" ]; then
318         additional_headers="Reply-To: ${template[reply-to]}
319 ${additional_headers}"
320     fi
321
322     if [ ! -z "${template[in-reply-to]}" ]; then
323         additional_headers="In-Reply-To: ${template[in-reply-to]}
324 ${additional_headers}"
325     fi
326
327     if [ ! -z "${template[cc]}" ]; then
328         additional_headers="Cc: ${template[cc]}
329 ${additional_headers}"
330     fi
331
332     if [ ! -z "${template[references]}" ]; then
333         additional_headers="References: ${template[references]}
334 ${additional_headers}"
335     fi
336
337     if [ ! -z "${template[content-type]}" ]; then
338         additional_headers="Content-Type: ${template[content-type]}
339 ${additional_headers}"
340     fi
341
342
343 cat <<EOF >"$gen_msg_filename"
344 From: ${template[from]}
345 To: ${template[to]}
346 Message-Id: <${gen_msg_id}>
347 Subject: ${template[subject]}
348 Date: ${template[date]}
349 ${additional_headers}
350 ${template[body]}
351 EOF
352
353     # Ensure that the mtime of the containing directory is updated
354     increment_mtime "$(dirname "${gen_msg_filename}")"
355 }
356
357 # Generate a new message and add it to the index.
358 #
359 # All of the arguments and return values supported by generate_message
360 # are also supported here, so see that function for details.
361 add_message ()
362 {
363     generate_message "$@" &&
364     notmuch new > /dev/null
365 }
366
367 test_begin_subtest ()
368 {
369     test_subtest_name="$1"
370 }
371
372 # Pass test if two arguments match
373 #
374 # Note: Unlike all other test_expect_* functions, this function does
375 # not accept a test name. Instead, the caller should call
376 # test_begin_subtest before calling this function in order to set the
377 # name.
378 test_expect_equal ()
379 {
380         test "$#" = 3 && { prereq=$1; shift; } || prereq=
381         test "$#" = 2 ||
382         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
383
384         output="$1"
385         expected="$2"
386         if ! test_skip "$@"
387         then
388                 if [ "$output" = "$expected" ]; then
389                         test_ok_ "$test_subtest_name"
390                 else
391                         testname=$this_test.$test_count
392                         echo "$expected" > $testname.expected
393                         echo "$output" > $testname.output
394                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
395                 fi
396     fi
397 }
398
399 NOTMUCH_NEW ()
400 {
401     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
402 }
403
404 notmuch_search_sanitize ()
405 {
406     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
407 }
408
409 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
410 notmuch_show_sanitize ()
411 {
412     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
413 }
414
415 # End of notmuch helper functions
416
417 # Use test_set_prereq to tell that a particular prerequisite is available.
418 # The prerequisite can later be checked for in two ways:
419 #
420 # - Explicitly using test_have_prereq.
421 #
422 # - Implicitly by specifying the prerequisite tag in the calls to
423 #   test_expect_{success,failure,code}.
424 #
425 # The single parameter is the prerequisite tag (a simple word, in all
426 # capital letters by convention).
427
428 test_set_prereq () {
429         satisfied="$satisfied$1 "
430 }
431 satisfied=" "
432
433 test_have_prereq () {
434         case $satisfied in
435         *" $1 "*)
436                 : yes, have it ;;
437         *)
438                 ! : nope ;;
439         esac
440 }
441
442 # You are not expected to call test_ok_ and test_failure_ directly, use
443 # the text_expect_* functions instead.
444
445 test_ok_ () {
446         test_success=$(($test_success + 1))
447         say_color pass "%-6s" "PASS"
448         echo " $@"
449 }
450
451 test_failure_ () {
452         test_failure=$(($test_failure + 1))
453         say_color error "%-6s" "FAIL"
454         echo " $1"
455         shift
456         echo "$@" | sed -e 's/^/        /'
457         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
458 }
459
460 test_known_broken_ok_ () {
461         test_fixed=$(($test_fixed+1))
462         say_color pass "%-6s" "FIXED"
463         echo " $@"
464 }
465
466 test_known_broken_failure_ () {
467         test_broken=$(($test_broken+1))
468         say_color pass "%-6s" "BROKEN"
469         echo " $@"
470 }
471
472 test_debug () {
473         test "$debug" = "" || eval "$1"
474 }
475
476 test_run_ () {
477         test_cleanup=:
478         eval >&3 2>&4 "$1"
479         eval_ret=$?
480         eval >&3 2>&4 "$test_cleanup"
481         return 0
482 }
483
484 test_skip () {
485         test_count=$(($test_count+1))
486         to_skip=
487         for skp in $NOTMUCH_SKIP_TESTS
488         do
489                 case $this_test.$test_count in
490                 $skp)
491                         to_skip=t
492                 esac
493         done
494         if test -z "$to_skip" && test -n "$prereq" &&
495            ! test_have_prereq "$prereq"
496         then
497                 to_skip=t
498         fi
499         case "$to_skip" in
500         t)
501                 say_color skip >&3 "skipping test: $@"
502                 say_color skip "%-6s" "SKIP"
503                 echo " $1"
504                 : true
505                 ;;
506         *)
507                 false
508                 ;;
509         esac
510 }
511
512 test_expect_failure () {
513         test "$#" = 3 && { prereq=$1; shift; } || prereq=
514         test "$#" = 2 ||
515         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
516         if ! test_skip "$@"
517         then
518                 test_run_ "$2"
519                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
520                 then
521                         test_known_broken_ok_ "$1"
522                 else
523                         test_known_broken_failure_ "$1"
524                 fi
525         fi
526 }
527
528 test_expect_success () {
529         test "$#" = 3 && { prereq=$1; shift; } || prereq=
530         test "$#" = 2 ||
531         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
532         if ! test_skip "$@"
533         then
534                 test_run_ "$2"
535                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
536                 then
537                         test_ok_ "$1"
538                 else
539                         test_failure_ "$@"
540                 fi
541         fi
542 }
543
544 test_expect_code () {
545         test "$#" = 4 && { prereq=$1; shift; } || prereq=
546         test "$#" = 3 ||
547         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
548         if ! test_skip "$@"
549         then
550                 test_run_ "$3"
551                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
552                 then
553                         test_ok_ "$2"
554                 else
555                         test_failure_ "$@"
556                 fi
557         fi
558 }
559
560 # test_external runs external test scripts that provide continuous
561 # test output about their progress, and succeeds/fails on
562 # zero/non-zero exit code.  It outputs the test output on stdout even
563 # in non-verbose mode, and announces the external script with "* run
564 # <n>: ..." before running it.  When providing relative paths, keep in
565 # mind that all scripts run in "trash directory".
566 # Usage: test_external description command arguments...
567 # Example: test_external 'Perl API' perl ../path/to/test.pl
568 test_external () {
569         test "$#" = 4 && { prereq=$1; shift; } || prereq=
570         test "$#" = 3 ||
571         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
572         descr="$1"
573         shift
574         if ! test_skip "$descr" "$@"
575         then
576                 # Announce the script to reduce confusion about the
577                 # test output that follows.
578                 say_color "" " run $test_count: $descr ($*)"
579                 # Run command; redirect its stderr to &4 as in
580                 # test_run_, but keep its stdout on our stdout even in
581                 # non-verbose mode.
582                 "$@" 2>&4
583                 if [ "$?" = 0 ]
584                 then
585                         test_ok_ "$descr"
586                 else
587                         test_failure_ "$descr" "$@"
588                 fi
589         fi
590 }
591
592 # Like test_external, but in addition tests that the command generated
593 # no output on stderr.
594 test_external_without_stderr () {
595         # The temporary file has no (and must have no) security
596         # implications.
597         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
598         stderr="$tmp/git-external-stderr.$$.tmp"
599         test_external "$@" 4> "$stderr"
600         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
601         descr="no stderr: $1"
602         shift
603         if [ ! -s "$stderr" ]; then
604                 rm "$stderr"
605                 test_ok_ "$descr"
606         else
607                 if [ "$verbose" = t ]; then
608                         output=`echo; echo Stderr is:; cat "$stderr"`
609                 else
610                         output=
611                 fi
612                 # rm first in case test_failure exits.
613                 rm "$stderr"
614                 test_failure_ "$descr" "$@" "$output"
615         fi
616 }
617
618 # This is not among top-level (test_expect_success | test_expect_failure)
619 # but is a prefix that can be used in the test script, like:
620 #
621 #       test_expect_success 'complain and die' '
622 #           do something &&
623 #           do something else &&
624 #           test_must_fail git checkout ../outerspace
625 #       '
626 #
627 # Writing this as "! git checkout ../outerspace" is wrong, because
628 # the failure could be due to a segv.  We want a controlled failure.
629
630 test_must_fail () {
631         "$@"
632         test $? -gt 0 -a $? -le 129 -o $? -gt 192
633 }
634
635 # test_cmp is a helper function to compare actual and expected output.
636 # You can use it like:
637 #
638 #       test_expect_success 'foo works' '
639 #               echo expected >expected &&
640 #               foo >actual &&
641 #               test_cmp expected actual
642 #       '
643 #
644 # This could be written as either "cmp" or "diff -u", but:
645 # - cmp's output is not nearly as easy to read as diff -u
646 # - not all diff versions understand "-u"
647
648 test_cmp() {
649         $GIT_TEST_CMP "$@"
650 }
651
652 # This function can be used to schedule some commands to be run
653 # unconditionally at the end of the test to restore sanity:
654 #
655 #       test_expect_success 'test core.capslock' '
656 #               git config core.capslock true &&
657 #               test_when_finished "git config --unset core.capslock" &&
658 #               hello world
659 #       '
660 #
661 # That would be roughly equivalent to
662 #
663 #       test_expect_success 'test core.capslock' '
664 #               git config core.capslock true &&
665 #               hello world
666 #               git config --unset core.capslock
667 #       '
668 #
669 # except that the greeting and config --unset must both succeed for
670 # the test to pass.
671
672 test_when_finished () {
673         test_cleanup="{ $*
674                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
675 }
676
677 test_done () {
678         GIT_EXIT_OK=t
679         test_results_dir="$TEST_DIRECTORY/test-results"
680         mkdir -p "$test_results_dir"
681         test_results_path="$test_results_dir/${0%.sh}-$$"
682
683         echo "total $test_count" >> $test_results_path
684         echo "success $test_success" >> $test_results_path
685         echo "fixed $test_fixed" >> $test_results_path
686         echo "broken $test_broken" >> $test_results_path
687         echo "failed $test_failure" >> $test_results_path
688         echo "" >> $test_results_path
689
690         echo
691
692         if [ "$test_failure" = "0" ]; then
693             rm -rf "$remove_tmp"
694             exit 0
695         else
696             exit 1
697         fi
698 }
699
700 find_notmuch_path ()
701 {
702     dir="$1"
703
704     while [ -n "$dir" ]; do
705         bin="$dir/notmuch"
706         if [ -x "$bin" ]; then
707             echo "$dir"
708             return
709         fi
710         dir="$(dirname "$dir")"
711         if [ "$dir" = "/" ]; then
712             break
713         fi
714     done
715 }
716
717 # Test the binaries we have just built.  The tests are kept in
718 # test/ subdirectory and are run in 'trash directory' subdirectory.
719 TEST_DIRECTORY=$(pwd)
720 if test -n "$valgrind"
721 then
722         make_symlink () {
723                 test -h "$2" &&
724                 test "$1" = "$(readlink "$2")" || {
725                         # be super paranoid
726                         if mkdir "$2".lock
727                         then
728                                 rm -f "$2" &&
729                                 ln -s "$1" "$2" &&
730                                 rm -r "$2".lock
731                         else
732                                 while test -d "$2".lock
733                                 do
734                                         say "Waiting for lock on $2."
735                                         sleep 1
736                                 done
737                         fi
738                 }
739         }
740
741         make_valgrind_symlink () {
742                 # handle only executables
743                 test -x "$1" || return
744
745                 base=$(basename "$1")
746                 symlink_target=$TEST_DIRECTORY/../$base
747                 # do not override scripts
748                 if test -x "$symlink_target" &&
749                     test ! -d "$symlink_target" &&
750                     test "#!" != "$(head -c 2 < "$symlink_target")"
751                 then
752                         symlink_target=../valgrind.sh
753                 fi
754                 case "$base" in
755                 *.sh|*.perl)
756                         symlink_target=../unprocessed-script
757                 esac
758                 # create the link, or replace it if it is out of date
759                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
760         }
761
762         # override notmuch executable in TEST_DIRECTORY/..
763         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
764         mkdir -p "$GIT_VALGRIND"/bin
765         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
766         OLDIFS=$IFS
767         IFS=:
768         for path in $PATH
769         do
770                 ls "$path"/notmuch 2> /dev/null |
771                 while read file
772                 do
773                         make_valgrind_symlink "$file"
774                 done
775         done
776         IFS=$OLDIFS
777         PATH=$GIT_VALGRIND/bin:$PATH
778         GIT_EXEC_PATH=$GIT_VALGRIND/bin
779         export GIT_VALGRIND
780 else # normal case
781         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
782         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
783 fi
784 export PATH
785
786 # Test repository
787 test="tmp.$(basename "$0" .sh)"
788 test -n "$root" && test="$root/$test"
789 case "$test" in
790 /*) TMP_DIRECTORY="$test" ;;
791  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
792 esac
793 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
794 rm -fr "$test" || {
795         GIT_EXIT_OK=t
796         echo >&5 "FATAL: Cannot prepare test area"
797         exit 1
798 }
799
800 MAIL_DIR="${TMP_DIRECTORY}/mail"
801 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
802
803 mkdir -p "${test}"
804 mkdir "$MAIL_DIR"
805
806 cat <<EOF >"${NOTMUCH_CONFIG}"
807 [database]
808 path=${MAIL_DIR}
809
810 [user]
811 name=Notmuch Test Suite
812 primary_email=test_suite@notmuchmail.org
813 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
814 EOF
815
816
817 # Use -P to resolve symlinks in our working directory so that the cwd
818 # in subprocesses like git equals our $PWD (for pathname comparisons).
819 cd -P "$test" || error "Cannot setup test environment"
820
821 this_test=${0##*/}
822 this_test=${this_test%%-*}
823 for skp in $NOTMUCH_SKIP_TESTS
824 do
825         to_skip=
826         for skp in $NOTMUCH_SKIP_TESTS
827         do
828                 case "$this_test" in
829                 $skp)
830                         to_skip=t
831                 esac
832         done
833         case "$to_skip" in
834         t)
835                 say_color skip >&3 "skipping test $this_test altogether"
836                 say_color skip "skip all tests in $this_test"
837                 test_done
838         esac
839 done
840
841 # Provide an implementation of the 'yes' utility
842 yes () {
843         if test $# = 0
844         then
845                 y=y
846         else
847                 y="$*"
848         fi
849
850         while echo "$y"
851         do
852                 :
853         done
854 }
855
856 # Fix some commands on Windows
857 case $(uname -s) in
858 *MINGW*)
859         # Windows has its own (incompatible) sort and find
860         sort () {
861                 /usr/bin/sort "$@"
862         }
863         find () {
864                 /usr/bin/find "$@"
865         }
866         sum () {
867                 md5sum "$@"
868         }
869         # git sees Windows-style pwd
870         pwd () {
871                 builtin pwd -W
872         }
873         # no POSIX permissions
874         # backslashes in pathspec are converted to '/'
875         # exec does not inherit the PID
876         ;;
877 *)
878         test_set_prereq POSIXPERM
879         test_set_prereq BSLASHPSPEC
880         test_set_prereq EXECKEEPSPID
881         ;;
882 esac
883
884 test -z "$NO_PERL" && test_set_prereq PERL
885 test -z "$NO_PYTHON" && test_set_prereq PYTHON
886
887 # test whether the filesystem supports symbolic links
888 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
889 rm -f y